Angular UI Components Documentation

Angular Menu Component

The Menu component for Angular represents a menu widget that makes it easy to add menus to your website or web application.

1. Installation

The easiest way to get started with jQWidgets UI for Angular is to use the Angular CLI Tool. To scaffold your project structure, follow its installation instructions.

npm install -g @angular/cli
ng new jqwidgets-project
cd jqwidgets-project

Install jQWidgets

jQWidgets Angular UI comes packaged with Angular CLI schematics to make creating Angular applications easier. Schematics are included with both @angular/cdk and jqwidgets-ng. Once you install the npm packages, they will be available through the Angular CLI.

Angular CLI supports the addition of packages through the ng add command. The ng add command provides faster and more user-friendly package installation. To install the jQWidgets UI for Angular package, use ng add and add the name of the NPM package:

ng add jqwidgets-ng

Alternatively, you can use the standard installation (Manual Setup)

jQWidgets UI for Angular is distributed as jqwidgets-ng NPM package

  1. Download and install the package.
    npm install jqwidgets-ng
  2. Adding CSS reference

    The following CSS file is available in ../node_modules/jqwidgets-ng/ package folder. This can be referenced in [src/styles.css] using following code.

    @import 'jqwidgets-ng/jqwidgets/styles/jqx.base.css';

    Another way to achieve the same is to edit the angular.json file and in the styles add the style.

    "styles": [
    	"node_modules/jqwidgets-ng/jqwidgets/styles/jqx.base.css"
    ]
    

2. Add the HTML for jQWidgets component in src/app/app.component.html

app.component.html


<div #jqxWidget style="height: 300px;">
  <jqxMenu [theme]="'fluent'" #menuReference [width]="getWidth()" [height]="30">
    <ul>
      <li><a href="#Home">Home</a></li>
      <li>
        Solutions
        <ul style="width: 250px;">
          <li><a href="#Education">Education</a></li>
          <li><a href="#Financial">Financial services</a></li>
          <li><a href="#Government">Government</a></li>
          <li><a href="#Manufacturing">Manufacturing</a></li>
          <li type="separator"></li>
          <li>
            Software Solutions
            <ul style="width: 220px;">
              <li><a href="#ConsumerPhoto">Consumer photo and video</a></li>
              <li><a href="#Mobile">Mobile</a></li>
              <li><a href="#RIA">Rich Internet applications</a></li>
              <li><a href="#TechnicalCommunication">Technical communication</a></li>
              <li><a href="#Training">Training and eLearning</a></li>
              <li><a href="#WebConferencing">Web conferencing</a></li>
            </ul>
          </li>
          <li><a href="#">All industries and solutions</a></li>
        </ul>
      </li>
      <li>
        Products
        <ul>
          <li><a href="#PCProducts">PC products</a></li>
          <li><a href="#MobileProducts">Mobile products</a></li>
          <li><a href="#AllProducts">All products</a></li>
        </ul>
      </li>
      <li>
        Support
        <ul style="width: 200px;">
          <li><a href="#SupportHome">Support home</a></li>
          <li><a href="#CustomerService">Customer Service</a></li>
          <li><a href="#KB">Knowledge base</a></li>
          <li><a href="#Books">Books</a></li>
          <li><a href="#Training">Training and certification</a></li>
          <li><a href="#SupportPrograms">Support programs</a></li>
          <li><a href="#Forums">Forums</a></li>
          <li><a href="#Documentation">Documentation</a></li>
          <li><a href="#Updates">Updates</a></li>
        </ul>
      </li>
      <li>
        Communities
        <ul style="width: 200px;">
          <li><a href="#Designers">Designers</a></li>
          <li><a href="#Developers">Developers</a></li>
          <li><a href="#Educators">Educators and students</a></li>
          <li><a href="#Partners">Partners</a></li>
          <li type="separator"></li>
          <li>
            By resource
            <ul>
              <li><a href="#Labs">Labs</a></li>
              <li><a href="#TV">TV</a></li>
              <li><a href="#Forums">Forums</a></li>
              <li><a href="#Exchange">Exchange</a></li>
              <li><a href="#Blogs">Blogs</a></li>
              <li><a href="#Experience Design">Experience Design</a></li>
            </ul>
          </li>
        </ul>
      </li>
      <li>
        Company
        <ul style="width: 180px;">
          <li><a href="#About">About Us</a></li>
          <li><a href="#Press">Press</a></li>
          <li><a href="#Investor">Investor Relations</a></li>
          <li><a href="#CorporateAffairs">Corporate Affairs</a></li>
          <li><a href="#Careers">Careers</a></li>
          <li><a href="#Showcase">Showcase</a></li>
          <li><a href="#Events">Events</a></li>
          <li><a href="#ContactUs">Contact Us</a></li>
          <li><a href="#Become an affiliate">Become an affiliate</a></li>
        </ul>
      </li>
    </ul>
  </jqxMenu>
  <br />
  <div style="margin-left: 60px;  margin-top: 120px;">
    <div style="font-size: 16px; font-family: Verdana Arial;">
      Settings
    </div>
    <div style="margin-top: 20px; font-size: 14px; font-family: Verdana Arial; float: left;">
      <jqxCheckBox [theme]="'fluent'" (onChange)="animationOnChange($event)"
                   [width]="150" [height]="20" [checked]="true">
        Enable Animation
      </jqxCheckBox>
      <div style="margin-top: 20px;">
        <jqxCheckBox [theme]="'fluent'" style="margin-top: 20px;" (onChange)="disabledOnChange($event)"
                     [width]="150" [height]="20" [checked]="false">
          Disabled
        </jqxCheckBox>
      </div>
    </div>
    <div style="margin-top: 20px; margin-left: 60px; font-size: 14px; font-family: Verdana Arial; float: left;">
      <jqxCheckBox [theme]="'fluent'" (onChange)="hoverOnChange($event)"
                   [width]="150" [height]="20" [checked]="true">
        Enable Hover
      </jqxCheckBox>
      <div style="margin-top: 20px;">
        <jqxCheckBox [theme]="'fluent'" (onChange)="openOnChange($event)"
                     [width]="150" [height]="20" [checked]="true">
          Auto Open
        </jqxCheckBox>
      </div>
    </div>
    <div style="margin-top: 20px; margin-left: 60px; font-size: 14px; font-family: Verdana Arial; float: left;">
      <jqxCheckBox [theme]="'fluent'" (onChange)="topLevelArrowsOnChange($event)"
                   [width]="200" [height]="20">
        Show Top-Level Arrows
      </jqxCheckBox>
    </div>
  </div>
</div>	

3. Setup Component Logic

app.component.ts


import { Component, ViewChild, ElementRef } from '@angular/core';

import { jqxCheckBoxComponent, jqxCheckBoxModule } from 'jqwidgets-ng/jqxcheckbox';
import { jqxMenuModule, jqxMenuComponent } from 'jqwidgets-ng/jqxmenu';
@Component({
    selector: 'app-root',
    imports: [jqxMenuModule, jqxCheckBoxModule],
    standalone: true,
    templateUrl: './app.component.html'
})

export class AppComponent {
    @ViewChild('menuReference') myMenu: jqxMenuComponent;

    getWidth(): any {
        if (document.body.offsetWidth < 600) {
            return '90%';
        }

        return 600;
    }

    animationOnChange(event: any): void {
        let value = event.args.checked;
        // enable or disable the menu's animation.
        if (!value) {
            this.myMenu.setOptions
                ({
                    animationShowDuration: 0,
                    animationHideDuration: 0,
                    animationShowDelay: 0
                });
        }
        else {
            this.myMenu.setOptions
                ({
                    animationShowDuration: 300,
                    animationHideDuration: 200,
                    animationShowDelay: 200
                });
        }
    }
    disabledOnChange(event: any): void {
        let value = event.args.checked;
        // enable or disable the menu
        if (!value) {
            this.myMenu.disabled(false);
        }
        else {
            this.myMenu.disabled(true);
        }
    }
    hoverOnChange(event: any): void {
        let value = event.args.checked;
        // enable or disable the menu's hover effect.
        if (!value) {
            this.myMenu.enableHover(false);
        }
        else {
            this.myMenu.enableHover(true);
        }
    }
    openOnChange(event: any): void {
        let value = event.args.checked;
        // enable or disable the opening of the top level menu items when the user hovers them.
        if (!value) {
            this.myMenu.autoOpen(false);
        }
        else {
            this.myMenu.autoOpen(true);
        }
    }
    topLevelArrowsOnChange(event: any): void {
        let value = event.args.checked;
        // enable or disable the top level arrows.
        if (!value) {
            this.myMenu.showTopLevelArrows(false);
        }
        else {
            this.myMenu.showTopLevelArrows(true);
        }
    }
}

Summary

jQWidgets UI for Angular provides an easy way to integrate robust UI components into your Angular project. By using either the ng add command or manual setup, you can quickly get started. Once the setup is complete, you can add the desired jQWidgets components and configure them in your Angular components to match your application requirements.

Menu API

API Reference of the jQWidgets Menu component for Angular: Menu API

React UI Components Documentation

ReactJS Menu Component

The Menu component for ReactJS represents a menu widget that makes it easy to add menus to your website or web application.

Prerequisites

Refer to ReactJS Getting Started before you start with this help topic.

Configuration

The Menu component for ReactJS requires the following imports.

 
import React from 'react';
import ReactDOM from 'react-dom';
import JqxMenu from 'jqwidgets-react/react_jqxmenu.js';

Then we create our component class. Properties and methods are put as ReactJS props.

  
class App extends React.Component {
render () {
return (
<jqxMenu width={220} height={22} autoOpen={true}>
<ul>
<li><a href="#Home">Home</a></li>
<li>
Solutions
<ul style={{ width: 250 }}>
<li><a href="#Education">Education</a></li>
<li><a href="#Financial">Financial services</a></li>
<li><a href="#Government">Government</a></li>
<li><a href="#Manufacturing">Manufacturing</a></li>
<li type='separator'></li>
<li><a href="#">All industries and solutions</a></li>
</ul>
</li>
<li>
Products
<ul>
<li><a href="#PCProducts">PC products</a></li>
<li><a href="#MobileProducts">Mobile products</a></li>
<li><a href="#AllProducts">All products</a></li>
</ul>
</li>
</ul>
</jqxMenu>
)
}
}

Finally we render our class in the desired HTML element:

 
ReactDOM.render(<App />, document.getElementById('app'));

Events Methods & Properties

In order to bind to any event, change any property or call any method, we need a reference to the component.
For that we use the ReactJS "ref" Callback Attribute:

 
<JqxMenu ref='myMenu' width={220} height={22}..... />

Now, when we have a reference, we need to call the desired event/property/method.
This is done in the componentDidMount() ReactJS Component Lifecycle method.

 
class App extends React.Component {
componentDidMount()
{
//your logic
}
render ()
{
return
(
....
)
}
};

Events

The closed event is triggered when any of the Menu Sub Menus is closed.

The following example demonstrates how to add an event listener:

 
componentDidMount ()
{
this.refs.myMenu.on('closed', (event) =>
{
//your logic
});
}

Methods & Properties

This is how you call methods & props:

Every component have a method setOptions which accepts a object as an argument. This object contains component settings.

 
this.refs.myMenu.setOptions({
minimizeWidth: 250, width: 200, height: 20
})

Every component also have a method getOptions which returns a object containing the component settings.

Menu Examples

Overview

The following example demonstrates how to create a Menu component.

 
import React from 'react';
import ReactDOM from 'react-dom';
import JqxMenu from 'jqwidgets-react/react_jqxmenu.js';
class App extends React.Component {
render () {
return (
<jqxMenu width={220} height={22} autoOpen={true}>
<ul>
<li><a href="#Home">Home</a></li>
<li>
Solutions
<ul style={{ width: 250 }}>
<li><a href="#Education">Education</a></li>
<li><a href="#Financial">Financial services</a></li>
<li><a href="#Government">Government</a></li>
<li><a href="#Manufacturing">Manufacturing</a></li>
<li type='separator'></li>
<li><a href="#">All industries and solutions</a></li>
</ul>
</li>
<li>
Products
<ul>
<li><a href="#PCProducts">PC products</a></li>
<li><a href="#MobileProducts">Mobile products</a></li>
<li><a href="#AllProducts">All products</a></li>
</ul>
</li>
</ul>
</jqxMenu>
)
}
}
ReactDOM.render(<App />, document.getElementById('app'));

Disabled Menu

The following example demonstrates how to disable the Menu component.

Menu API

API Reference of the jQWidgets Menu component for React: Menu API

Vue UI Components Documentation

Vue Menu Component

The Menu component for Vue represents a menu widget that makes it easy to add menus to your website or web application.

Prerequisites

Refer to Vue Getting Started before you start with this help topic.

Configuration

After you have created your App.vue file, here is how you should structure it:

The Menu component for Vue requires the following import:


Add the jqxMenu component to the components section of the the Vue class:


Template

The App.vue has a <template> structural tag where we determine the application structure. There we will also set the tags for the new components - <JqxMenu/>

<template>
<JqxMenu :mode="mode" :enableHover="enableHover"
:width="600" :height="30">
<ul>
<li><a href="#Home">Home</a></li>
<li>
Solutions
<ul style="width: 250px;">
<li><a href="#Education">Education</a></li>
<li><a href="#Financial">Financial services</a></li>
<li><a href="#Government">Government</a></li>
<li><a href="#Manufacturing">Manufacturing</a></li>
<li type="separator"></li>
<li>
Software Solutions
<ul style="width: 220px;">
<li><a href="#ConsumerPhoto">Consumer photo and video</a></li>
<li><a href="#Mobile">Mobile</a></li>
<li><a href="#RIA">Rich Internet applications</a></li>
<li><a href="#TechnicalCommunication">Technical communication</a></li>
<li><a href="#Training">Training and eLearning</a></li>
<li><a href="#WebConferencing">Web conferencing</a></li>
</ul>
</li>
<li><a href="#">All industries and solutions</a></li>
</ul>
</li>
<li>
Products
<ul>
<li><a href="#PCProducts">PC products</a></li>
<li><a href="#MobileProducts">Mobile products</a></li>
<li><a href="#AllProducts">All products</a></li>
</ul>
</li>
<li>
Support
<ul style="width: 200px;">
<li><a href="#SupportHome">Support home</a></li>
<li><a href="#CustomerService">Customer Service</a></li>
<li><a href="#KB">Knowledge base</a></li>
<li><a href="#Books">Books</a></li>
<li><a href="#Training">Training and certification</a></li>
<li><a href="#SupportPrograms">Support programs</a></li>
<li><a href="#Forums">Forums</a></li>
<li><a href="#Documentation">Documentation</a></li>
<li><a href="#Updates">Updates</a></li>
</ul>
</li>
<li>
Communities
<ul style="width: 200px;">
<li><a href="#Designers">Designers</a></li>
<li><a href="#Developers">Developers</a></li>
<li><a href="#Educators">Educators and students</a></li>
<li><a href="#Partners">Partners</a></li>
<li type="separator"></li>
<li>
By resource
<ul>
<li><a href="#Labs">Labs</a></li>
<li><a href="#TV">TV</a></li>
<li><a href="#Forums">Forums</a></li>
<li><a href="#Exchange">Exchange</a></li>
<li><a href="#Blogs">Blogs</a></li>
<li><a href="#Experience Design">Experience Design</a></li>
</ul>
</li>
</ul>
</li>
<li>
Company
<ul style="width: 180px;">
<li><a href="#About">About Us</a></li>
<li><a href="#Press">Press</a></li>
<li><a href="#Investor">Investor Relations</a></li>
<li><a href="#CorporateAffairs">Corporate Affairs</a></li>
<li><a href="#Careers">Careers</a></li>
<li><a href="#Showcase">Showcase</a></li>
<li><a href="#Events">Events</a></li>
<li><a href="#ContactUs">Contact Us</a></li>
<li><a href="#Become an affiliate">Become an affiliate</a></li>
</ul>
</li>
</ul>
</JqxMenu>
</template>

Properties

The properties of the <JqxMenu/> component are defined in the data member of the Vue class. We should put them in the return object of the data function:

data: function () {
return {
mode: 'horizontal',
enableHover: false
}
}

Events

The events in Vue are set as an attribute with @ prefix, for example:

<JqxMenu @itemclick="onItemClick()"
:mode="mode" :enableHover="enableHover"
:width="600" :height="30">
<ul>
<li><a href="#Home">Home</a></li>
<li>
Solutions
<ul style="width: 250px;">
<li><a href="#Education">Education</a></li>
<li><a href="#Financial">Financial services</a></li>
<li><a href="#Government">Government</a></li>
<li><a href="#Manufacturing">Manufacturing</a></li>
<li type="separator"></li>
<li>
Software Solutions
<ul style="width: 220px;">
<li><a href="#ConsumerPhoto">Consumer photo and video</a></li>
<li><a href="#Mobile">Mobile</a></li>
<li><a href="#RIA">Rich Internet applications</a></li>
<li><a href="#TechnicalCommunication">Technical communication</a></li>
<li><a href="#Training">Training and eLearning</a></li>
<li><a href="#WebConferencing">Web conferencing</a></li>
</ul>
</li>
<li><a href="#">All industries and solutions</a></li>
</ul>
</li>
<li>
Products
<ul>
<li><a href="#PCProducts">PC products</a></li>
<li><a href="#MobileProducts">Mobile products</a></li>
<li><a href="#AllProducts">All products</a></li>
</ul>
</li>
<li>
Support
<ul style="width: 200px;">
<li><a href="#SupportHome">Support home</a></li>
<li><a href="#CustomerService">Customer Service</a></li>
<li><a href="#KB">Knowledge base</a></li>
<li><a href="#Books">Books</a></li>
<li><a href="#Training">Training and certification</a></li>
<li><a href="#SupportPrograms">Support programs</a></li>
<li><a href="#Forums">Forums</a></li>
<li><a href="#Documentation">Documentation</a></li>
<li><a href="#Updates">Updates</a></li>
</ul>
</li>
<li>
Communities
<ul style="width: 200px;">
<li><a href="#Designers">Designers</a></li>
<li><a href="#Developers">Developers</a></li>
<li><a href="#Educators">Educators and students</a></li>
<li><a href="#Partners">Partners</a></li>
<li type="separator"></li>
<li>
By resource
<ul>
<li><a href="#Labs">Labs</a></li>
<li><a href="#TV">TV</a></li>
<li><a href="#Forums">Forums</a></li>
<li><a href="#Exchange">Exchange</a></li>
<li><a href="#Blogs">Blogs</a></li>
<li><a href="#Experience Design">Experience Design</a></li>
</ul>
</li>
</ul>
</li>
<li>
Company
<ul style="width: 180px;">
<li><a href="#About">About Us</a></li>
<li><a href="#Press">Press</a></li>
<li><a href="#Investor">Investor Relations</a></li>
<li><a href="#CorporateAffairs">Corporate Affairs</a></li>
<li><a href="#Careers">Careers</a></li>
<li><a href="#Showcase">Showcase</a></li>
<li><a href="#Events">Events</a></li>
<li><a href="#ContactUs">Contact Us</a></li>
<li><a href="#Become an affiliate">Become an affiliate</a></li>
</ul>
</li>
</ul>
</JqxMenu>

All events that are bound to a component are implemented in the methods member of the Vue class.


Methods

To use a component's method we should have its reference. In Vue we refer to a component by the special $refs property. Before that we need to add the desired name reference to that component:

<JqxMenu ref="menu"></JqxMenu>

Here how you can use a component's method:

this.$refs.menu.minimize();

If we want to add additional methods we should also implement them in the methods member.

In case we need to do some precalculation or something else before the components are rendered, we should use the beforeCreate member. It depends on the case.

If you have followed the above steps, you App.vue file would look like this:

App.vue:

Menu Example

Run Code